(*--------------------------------------------------------------------------+
 |                                                                          |
 |                   Bote  outils pour les arbres gnraux                |
 |                                                                          |
 |  M. Quercia, le 06/08/96                                                 |
 +--------------------------------------------------------------------------+*)


type 'a g_arbre = G_noeud of 'a * ('a g_arbre list);;

value g_map : ('a -> 'b) -> ('a g_arbre -> 'b g_arbre);;
(* "g_map f a" applique "f"  chaque noeud de "a" et renvoie
   l'arbre des rsultats *)

value g_arbre : string -> string g_arbre;;
(* "g_arbre chaine" interprte "chaine" comme la description parenthse
   d'un arbre et renvoie cet arbre *)

value print_g_arbre : string g_arbre -> unit;;
(* "print_g_arbre a" imprime "a" sous forme graphique.
   Les fonctions d'impression sont celles de la bibliothque "format" *)

value int_g_arbre : string -> int g_arbre;;
value print_int_g_arbre : int g_arbre -> unit;;
(* lecture et impression d'arbres  tiquettes entires *)
